#include <bits/stdc++.h>
using namespace std;
int kolko1[26];
int kolko2[26];
int kolko11[26];
int kolko22[26];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    string s;
    cin>>s;
    int n=s.length();
    int l=0,r=n-1;
    while(l!=r && s[l]==s[r])
    {
        l++;
        r--;
    }
    int ll,rr;
    if(n%2==0)
    {
        ll=n/2-1;
        rr=n/2;
    }
    else
    {
        ll=n/2;
        rr=n/2;
    }
    while(ll>=l && rr<=r && s[ll]==s[rr])
    {
        ll--;
        rr++;
    }
    for(int i=l;i<=ll;i++) kolko1[s[i]-'a']++;
    for(int i=rr;i<=r;i++) kolko2[s[i]-'a']++;
    bool li=true;
    for(int i=0;i<26;i++)
    {
        if(kolko1[i]!=kolko2[i]) li=false;
    }
    if(li)
    {
        if(ll<l) cout<<1<<endl;
        else cout<<ll-l+1<<endl;
    }
    else
    {
        for(int i=0;i<26;i++)
        {
            kolko11[i]=kolko1[i];
            kolko22[i]=kolko2[i];
        }
        int lol=n+1;
        int xd=n+1;
        for(int i=ll;i>=l;i--)
        {
            kolko2[s[i]-'a']++;
            kolko1[s[i]-'a']--;
            bool ali=true;
            for(int j=0;j<26;j++)
            {
                if(kolko1[j]>kolko2[j]) ali=false;
            }
            if(ali)
            {
                lol=min(r-i+1,lol);
                //cout<<i<<endl;
                //cout<<"sa desna"<<endl;
                //break;
            }
        }
        for(int i=rr;i<=r;i++)
        {
            kolko22[s[i]-'a']--;
            kolko11[s[i]-'a']++;
            bool alii=true;
            for(int j=0;j<26;j++)
            {
                if(kolko11[j]<kolko22[j]) alii=false;
            }
            if(alii)
            {
                xd=min(i-l+1,xd);
                //cout<<i<<endl;
                //break;
            }
        }
        cout<<min(xd,lol)<<endl;
    }
}